ccc  massfunc_de.f    Time-stamp: <2007-06-01 10:33:09 hamanatk>
ccc  If this does not work well, try the compile option that
ccc  sets default size of REAL to 8 bytes, such like
ccc  "-r8" or  "-real_size 64"
ccc  ***FLAT MODEL ONLY***
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /cosmo/ om,ode,w0,wa
      common /omegas/ omem,omev,omek
      common /matter_Pk/ gamfin,atps
      common /defs/ pi,tps,ch0,rn,onethr
      common /st/ p_st,a_st,st_norm

ccc growth factor
      external derivs
      parameter (nstep=1000)
      parameter (hrk=0.001)
      dimension dplus(0:nstep)
      dimension growpd(0:nstep)
      parameter (nrk4=2)
      real yrk(nrk4),dydxrk(nrk4),youtrk(nrk4)

      parameter (numin=-250)
      parameter (numax=250)
      parameter (delnu=0.01)

      character*99 fname

      dimension ym(numin:numax)
      dimension xm(numin:numax)
      dimension stmf0(numin:numax)
      dimension stmfm(numin:numax)
      dimension stmflog10(numin:numax)

clear array
      do i=numin,numax
         ym(i)=0.0
         xm(i)=0.0
      enddo

ccc useful numbers
      pi=4.0*atan(1.0)
      tps=2.0*pi**2
      ch0=3000.0
      rn=8.0/ch0
      onethr=1.0/3.0
      e2ten=2.30259 !ln(x)=ln(10)*log(x), ln(10)=e2ten
      zero=0.0
      rhocr=2.7755e11 ! M_sun h^2 /Mpc^3
      
ccc flags
      igrfrag=-1

ccc 
      write(*,*)'### massfunc_de.f'
      write(*,*)'### version-1 [01/06/2007]'
      write(*,*)'###'
      write(*,*)'### Use this at your own risk' 
      write(*,*)'### Bug report to Takashi Hamana'
      write(*,*)'###'
      write(*,*)'### If this does not work well'
      write(*,*)'### try a compile option that'
      write(*,*)'### defines REAL as DOUBLE PRECISION (REAL*8)'
      write(*,*)'### such like "-r8" or "-real_size 64"'
      write(*,*)'###'
      write(*,*)'### This uses BBKS CDM transfer function'
      write(*,*)'### with Sugiyama95 fitting function for Gamma'
      write(*,*)'###'
      write(*,*)'### NOTE **Valid only for Flat cosmology**'
      write(*,*)'###        Omega_m+Lambda should be 1'
      write(*,*)'#########################################'

ccc mass function
 901  write(*,*)'[1] ST99 [2] PS'
      read(*,*)imodel
      if (imodel.eq.2) then
         p_st=0.0  ! PS parameter 
         a_st=1.0  ! PS parameter
      elseif (imodel.eq.1) then
         p_st=0.3    ! ST parameter 
         a_st=0.707  ! ST parameter 
      else
         goto 901
      endif

 21   write(*,*)'First of all'
      write(*,*)'input the cosmological parameters' 
      write(*,*)'for P(k) normalization'
      write(*,*)'1 or 2 ?'
      write(*,*)'1: LCDM + sigma_8=0.9'
      write(*,*)'     Omega_m=0.3'
      write(*,*)'     Omega_b=0.04'
      write(*,*)'           h=0.7'
      write(*,*)'2: something else'
      read(*,*)inorm8
      
      if (inorm8.eq.1) then
         om=0.3
         ode=1.0-om
         w0=-1.0
         wa=0.0
         ob=0.04
         sig8=0.9
         hubp=0.7
      elseif (inorm8.eq.2) then
         write(*,*)'Omega_m ?'
         read(*,*)om
         ode=1.0-om
         write(*,*)'Omega_b ?'
         read(*,*)ob
         write(*,*)'w0 ?'
         read(*,*)w0
         write(*,*)'wa ?'
         read(*,*)wa
         write(*,*)'h ?'
         read(*,*)hubp
         write(*,*)'sigma_8 ?'
         read(*,*)sig8
      else
         goto 21
      endif
      omem=om
      omev=ode
      omeb=ob
      omebh2=omeb*hubp**2
      omek=0.0
      rho0=omem*rhocr

ccc Gamma factor
      gamfin=exp(omeb+sqrt(2.0*hubp)*omeb/omem)/
     $     (omem*hubp*ch0)

ccc normalization
      call normPk(anrm,sig8)
      atps=anrm/tps
      
!!!!! compute the linear growth factor D+(a)=a*g(a)
      ax=0.0
      growpd(0)=1.0

      x=ax
      yrk(1)=1.0
      yrk(2)=0.0
      dydxrk(1)=0.0
      dydxrk(2)=0.0
      call rk4(yrk,dydxrk,nrk4,x,hrk,youtrk,derivs)
      yrk(1)=youtrk(1)
      yrk(2)=youtrk(2)
      growpd(1)=yrk(1)
      
      do i=2,nstep
         x=hrk*(i-1)
         call derivs(x,yrk,dydxrk)
         call rk4(yrk,dydxrk,nrk4,x,hrk,youtrk,derivs)
         yrk(1)=youtrk(1)
         yrk(2)=youtrk(2)
         growpd(i)=yrk(1)
      enddo
      growpd_norm=growpd(nstep)

      write(*,*)'Ok, then input the cosmo params of your interest'
 11   write(*,*)'Cosmology 1, 2, 3 or 4 ?'
      write(*,*)'*** Flat model only (Omage_m + Omega_de = 1) ***'
      write(*,*)'1: Lambda (Omega_m=0.3, w=-1)'
      write(*,*)'2: Eds    (Omega_m=1.0, w=-1)'
      write(*,*)'3: DE model [w(a)=w0+wa*(1-a)] with Omega_m = 0.3'
      write(*,*)'4: Something else'
      read(*,*)icosmo
      
      if (icosmo.eq.1) then
         om=0.3
         ode=1.0-om
         w0=-1.0
         wa=0.0
      elseif (icosmo.eq.2) then
         om=1.0
         ode=1.0-om
         w0=-1.0
         wa=0.0
      elseif (icosmo.eq.3) then
         om=0.3
         ode=1.0-om
         write(*,*)'w0 ?'
         read(*,*)w0
         write(*,*)'wa ?'
         read(*,*)wa
      elseif (icosmo.eq.4) then
         write(*,*)'Omega_m ?'
         read(*,*)om
         ode=1.0-om
         write(*,*)'w0 ?'
         read(*,*)w0
         write(*,*)'wa ?'
         read(*,*)wa
      else
         goto 11
      endif

 12   write(*,*)'Hubble parameter 1, 2 or 3 ?'
      write(*,*)'1: h=0.7'
      write(*,*)'2: h=0.5'
      write(*,*)'3: something else'
      read(*,*)icosmo
      
      if (icosmo.eq.1) then
         hubp=0.7
      elseif (icosmo.eq.2) then
         hubp=0.5
      elseif (icosmo.eq.3) then
         write(*,*)'h ?'
         read(*,*)hubp
      else
         goto 12
      endif

 13   write(*,*)'Baryon density 1, 2 or 3 ?'
      write(*,*)'1: Omega_b=0.04'
      write(*,*)'2: Omega_b=0.0'
      write(*,*)'3: something else'
      read(*,*)icosmo
      
      if (icosmo.eq.1) then
         ob=0.04
      elseif (icosmo.eq.2) then
         ob=0.0
      elseif (icosmo.eq.3) then
         write(*,*)'Omega_b ?'
         read(*,*)ob
      else
         goto 13
      endif
      omem=om
      omev=ode
      omeb=ob
      omebh2=omeb*hubp**2
      omek=0.0
      rho0=omem*rhocr
      
ccc Gamma factor
      gamfin=exp(omeb+sqrt(2.0*hubp)*omeb/omem)/
     $     (omem*hubp*ch0)

ccc realization redshift 
      write(*,*)'redshift ?'
      read(*,*)zs
      as=1.0/(1.0+zs)

ccc output file name
      write(*,*)'output file name ?'
      read(*,'(a99)')fname

!!!!! compute the linear growth factor D+(a)=a*g(a)
      ax=0.0
      growpd(0)=1.0

      x=ax
      yrk(1)=1.0
      yrk(2)=0.0
      dydxrk(1)=0.0
      dydxrk(2)=0.0
      call rk4(yrk,dydxrk,nrk4,x,hrk,youtrk,derivs)
      yrk(1)=youtrk(1)
      yrk(2)=youtrk(2)
      growpd(1)=yrk(1)
      
      do i=2,nstep
         x=hrk*(i-1)
         call derivs(x,yrk,dydxrk)
         call rk4(yrk,dydxrk,nrk4,x,hrk,youtrk,derivs)
         yrk(1)=youtrk(1)
         yrk(2)=youtrk(2)
         growpd(i)=yrk(1)
      enddo
      do i=0,nstep
         ax=i*hrk
         dplus(i)=growpd(i)/growpd(nstep)*ax
      enddo

ccc scaling sigma_8
      sig8=sig8*growpd(nstep)/growpd_norm
      anrm=anrm*(growpd(nstep)/growpd_norm)**2
      atps=atps*(growpd(nstep)/growpd_norm)**2
c      write(*,*)sig8

ccc construct mass function
      call int_st(st_norm)

ccc construct sigma-R relation at z=0
      call int_sigmar

ccc growth rate at zs
      ga2=gra(as,nstep,hrk,dplus)**2
      g=sqrt(ga2)/as
c      write(*,*)ga2,g

ccc Virial overdensity delta_vir at zs
      call deltas(as,deltac,deltavir)
      deltac2=deltac**2
      deltavir3=deltavir**onethr

ccc r_ast at zs
      call search_rast(rast,ga2,deltac2)

      do 30 inu=numin,numax     ! loop for nu
cccccc for nu=nu(inu)
         anu=10.0**(inu*delnu)  ! nu
         sigma2_nu=deltac2/anu  ! sigma^2
         rnu=sigma2r(sigma2_nu,ga2) ! R

         amss=4.0*pi*rho0*rnu**3/3.0
         coef=st_norm*rho0/amss

         stmf=coef*fnu_nu(anu)/anu

         anu1=10.0**((inu+0.1)*delnu)
         sigma2_nu=deltac2/anu1
         rnu=sigma2r(sigma2_nu,ga2)
         amass1=4.0*pi*rho0*rnu**3/3.0
         
         anu2=10.0**((inu-0.1)*delnu)
         sigma2_nu=deltac2/anu2
         rnu=sigma2r(sigma2_nu,ga2)
         amass2=4.0*pi*rho0*rnu**3/3.0
         
         dnudm=(anu1-anu2)/(amass1-amass2)
         stmf0(inu)=stmf*dnudm
         stmfm(inu)=stmf*dnudm*amss
         dnudlog10m=(anu1-anu2)/(log10(amass1)-log10(amass2))
         stmflog10(inu)=stmf*dnudlog10m
         
         ym(inu)=stmf0(inu)
         xm(inu)=amss

 30   continue

      open(10,file=fname,status='unknown')
      write(10,'(a47)')'# M; dn(M)/dM; M*dn(M)/dM; dn(M)/dlog10M; n(>M)'
      do inu=numin,numax     ! loop for nu
         z=0.0
         do j=inu,numax-1
            dm=xm(j+1)-xm(j)
            z=z+0.5*(ym(j+1)+ym(j))*dm
         enddo
         write(10,100)xm(inu),stmf0(inu),stmfm(inu),
     $        stmflog10(inu),z
      enddo
 100  format(5(1pe13.5))
      close(10)
      end


ccc Sheth & Tormen mass function ! NOT normalized
      function fnu_nu(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /st/ p,a,st_norm
      y=a*x
      fnu_nu=(1.0+1.0/y**p)*sqrt(y)*exp(-0.5*y)
      return
      end

ccc normalization of Sheth & Tormen mass function    
      subroutine int_st(st_norm)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      external fnu_nu_log
      amin=-80.0
      amax=80.0
      call qromb(fnu_nu_log,amin,amax,ss)
      st_norm=1.0/ss
      return
      end
      function fnu_nu_log(z)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /st/ p,a,st_norm
      x=exp(z)
      y=a*x
      fnu_nu_log=(1.0+y**(-p))*sqrt(y)*exp(-0.5*y)
      return
      end

ccc delta_c and delta_vir 
ccc VALID only FLAT model
      subroutine deltas(a,deltac,deltavir)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /omegas/ omem,omev,omek
      common /defs/ pi,tps,ch0,rn,onethr
      x=a*(1.0/omem-1.0)**(1.0/3.0)
      deltac=3.0*(12.0*pi)**(2.0/3.0)/20.0*
     $     (1.0-0.00123*log10(1.0+x**3))
      deltavir=18.0*pi**2*(1.0+0.4093*x**2.71572)
      return
      end


      subroutine search_rast(rast,ga2,deltac2)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigma_r_relation/ sigmar0,r0,drdsig1,drdsig2
      parameter (irmin=-350)
      parameter (irmax=250)
      parameter (delr=0.02)
      parameter (irall=irmax-irmin+1)
      dimension sigmar0(irall)
      dimension r0(irall)
      sig0=log(deltac2/ga2)
      call hunt(sigmar0,irall,sig0,jlo)
      d=(r0(jlo+1)-r0(jlo))/(sigmar0(jlo+1)-sigmar0(jlo))
      r1=d*(sig0-sigmar0(jlo))+r0(jlo)
      rast=exp(r1)
      return
      end
ccc sigma_R - R relation
      subroutine int_sigmar
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigma_r_relation/ sigmar0,r0,drdsig1,drdsig2
      parameter (irmin=-350)
      parameter (irmax=250)
      parameter (delr=0.02)
      parameter (irall=irmax-irmin+1)
      dimension sigmar0(irall)
      dimension r0(irall)
      do 10 i=1,irall
         ii=irmax-i+1
         x=10.0**(delr*ii)
         r0(i)=log(x)
         sigmar0(i)=log(sigma_r(x)) ! Notice sigma_r(x)=sigma_R^2
 10   continue
      drdsig1=(r0(2)-r0(1))/(sigmar0(2)-sigmar0(1))
      drdsig2=(r0(irall)-r0(irall-1))/
     $     (sigmar0(irall)-sigmar0(irall-1))
      return
      end
ccc
      function sigma2r(sig,ga2)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigma_r_relation/ sigmar0,r0,drdsig1,drdsig2
      parameter (irmin=-350)
      parameter (irmax=250)
      parameter (delr=0.02)
      parameter (irall=irmax-irmin+1)
      dimension sigmar0(irall)
      dimension r0(irall)
      sig0=log(sig/ga2)
      if (sig0.le.sigmar0(1)) then
         y=r0(1)+drdsig1*(sig0-sigmar0(1))
      elseif (sig0.ge.sigmar0(irall)) then
         y=r0(irall)+drdsig2*(sig0-sigmar0(irall))
      else
         call hunt(sigmar0,irall,sig0,jlo)
         d=(r0(jlo+1)-r0(jlo))/(sigmar0(jlo+1)-sigmar0(jlo))
         y=d*(sig0-sigmar0(jlo))+r0(jlo)
      endif
      sigma2r=exp(y)
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccc
      function sigma_r(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /defs/ pi,tps,ch0,rn,onethr
      common /sigmar/rsmooth
      external dsigma_r
      wmin=-30.0
      wmax=40.0
      rsmooth=x/ch0
      call qromb(dsigma_r,wmin,wmax,ss)
      sigma_r=ss
      return
      end   
ccccccccccccccccccccccccccccccccccccccccccccc
      function dsigma_r(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigmar/rsmooth
      w=exp(x)
      rk=rsmooth*w
      dsigma_r=delta_lin0(w)*filtTH(rk)**2
      return
      end 
ccccccccccccccccccccccccccccccccccccccccccccc
      function delta_lin0(w)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /matter_Pk/ gfin,atps
      q=w*gfin
      delta_lin0=atps*trnf2(q)*w**4
      return
      end 

cccccccccc normalization of power spectrum 
      subroutine normPk(a_norm,sig8)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      external delta
      common /defs/ pi,tps,ch0,rn,onethr
      wmin=-30.0
      wmax=40.0
      call qromb(delta,wmin,wmax,seki)
      y=seki/tps
      a_norm=sig8*sig8/y
      return
      end
ccccccccc
      function delta(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /defs/ pi,tps,ch0,rn,onethr
      common /matter_Pk/ gfin,atps
      w=exp(x)
      q=w*gfin
      r=w*rn
      filt=filtTH(r)
      tranf=trnf2(q)
      delta=w**4*filt*filt*tranf
      return
      end
ccccccccc
      function filtTH(r)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      filtTH=3.0*(sin(r)-r*cos(r))/r**3
      return
      end
ccccccccc 
      function trnf2(q)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /matter_Pk/ gamfin,atps
      qq=q*q
      trnf2=0.182628*log(1.0+2.34*q)**2/qq
     $     /sqrt(1.0+3.89*q+259.21*qq
     $     +162.77*qq*q+2027.17*qq*qq)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccc
c      function gr(a,igrfrag)
c      implicit real (a-h,o-z)
c      implicit integer (i-n)
c      common /omegas/ omem,omev,omek
c      save grnorm
c      if (igrfrag.eq.-1) then
c         pre=1.0
c         et=1.0/e(pre)
c         ot=omem*et
c         vt=omev*et
c         grnorm=0.4*(ot**(0.571428571)-vt+
c     $        (1.0+0.5*ot)*(1.0+vt*0.014285714))/ot
c         igrfrag=1
c      endif
c      et=1.0/e(a)
c      ot=omem*a*et
c      vt=omev*et*a**4
c      graw=2.5*ot/(ot**(0.571428571)-vt+
c     $     (1.0+0.5*ot)*(1.0+vt*0.014285714))
c      gr=graw*grnorm
c      return
c      end
ccc      
c      function e(a)
c      implicit real (a-h,o-z)
c      implicit integer (i-n)
c      common /omegas/ omem,omev,omek
c      a2=a*a
c      e=a*omem-a2*omek+a2*a2*omev
c      return
c      end

ccc QROMB package
      SUBROUTINE qromb(func,a,b,ss)
      INTEGER JMAX,JMAXP,K,KM
      REAL a,b,func,ss,EPS
      EXTERNAL func
      PARAMETER (EPS=1.e-6, JMAX=40, JMAXP=JMAX+1, K=10, KM=K-1)
CU    USES polint,trapzd
      INTEGER j
      REAL dss,h(JMAXP),s(JMAXP)
      h(1)=1.
      do 11 j=1,JMAX
        call trapzd(func,a,b,s(j),j)
        if (j.ge.K) then
          call polint(h(j-KM),s(j-KM),K,0.,ss,dss)
          if (abs(dss).le.EPS*abs(ss)) return
        endif
        s(j+1)=s(j)
        h(j+1)=0.25*h(j)
11    continue
      pause 'too many steps in qromb'
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE polint(xa,ya,n,x,y,dy)
      INTEGER n,NMAX
      REAL dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=20)
      INTEGER i,m,ns
      REAL den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint'
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE trapzd(func,a,b,s,n)
      INTEGER n
      REAL a,b,s,func
      EXTERNAL func
      INTEGER it,j
      REAL del,sum,tnm,x
      if (n.eq.1) then
        s=0.5*(b-a)*(func(a)+func(b))
      else
        it=2**(n-2)
        tnm=it
        del=(b-a)/tnm
        x=a+0.5*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(x)
          x=x+del
11      continue
        s=0.5*(s+(b-a)*sum/tnm)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.

      SUBROUTINE hunt(xx,n,x,jlo)
      INTEGER jlo,n
      REAL x,xx(n)
      INTEGER inc,jhi,jm
      LOGICAL ascnd
      ascnd=xx(n).gt.xx(1)
      if(jlo.le.0.or.jlo.gt.n)then
        jlo=0
        jhi=n+1
        goto 3
      endif
      inc=1
      if(x.ge.xx(jlo).eqv.ascnd)then
1       jhi=jlo+inc
        if(jhi.gt.n)then
          jhi=n+1
        else if(x.ge.xx(jhi).eqv.ascnd)then
          jlo=jhi
          inc=inc+inc
          goto 1
        endif
      else
        jhi=jlo
2       jlo=jhi-inc
        if(jlo.lt.1)then
          jlo=0
        else if(x.lt.xx(jlo).eqv.ascnd)then
          jhi=jlo
          inc=inc+inc
          goto 2
        endif
      endif
3     if(jhi-jlo.eq.1)return
      jm=(jhi+jlo)/2
      if(x.gt.xx(jm).eqv.ascnd)then
        jlo=jm
      else
        jhi=jm
      endif
      goto 3
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.

      FUNCTION rtflsp(func,x1,x2,xacc)
      INTEGER MAXIT
      REAL rtflsp,x1,x2,xacc,func
      EXTERNAL func
      PARAMETER (MAXIT=1000)
      INTEGER j
      REAL del,dx,f,fh,fl,swap,xh,xl
      fl=func(x1)
      fh=func(x2)
      if(fl*fh.gt.0.) pause 'root must be bracketed in rtflsp'
      if(fl.lt.0.)then
        xl=x1
        xh=x2
      else
        xl=x2
        xh=x1
        swap=fl
        fl=fh
        fh=swap
      endif
      dx=xh-xl
      do 11 j=1,MAXIT
        rtflsp=xl+dx*fl/(fl-fh)
        f=func(rtflsp)
        if(f.lt.0.) then
          del=xl-rtflsp
          xl=rtflsp
          fl=f
        else
          del=xh-rtflsp
          xh=rtflsp
          fh=f
        endif
        dx=xh-xl
        if(abs(del).lt.xacc.or.f.eq.0.)return
11    continue
      pause 'rtflsp exceed maximum iterations'
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.

CCC QROMB2 
      SUBROUTINE qromb2(func,a,b,ss)
      INTEGER JMAX,JMAXP,K,KM
      REAL a,b,func,ss,EPS
      EXTERNAL func
      PARAMETER (EPS=1.e-6, JMAX=20, JMAXP=JMAX+1, K=5, KM=K-1)
CU    USES polint2,trapzd2
      INTEGER j
      REAL dss,h(JMAXP),s(JMAXP)
      h(1)=1.
      do 11 j=1,JMAX
        call trapzd2(func,a,b,s(j),j)
        if (j.ge.K) then
          call polint2(h(j-KM),s(j-KM),K,0.,ss,dss)
          if (abs(dss).le.EPS*abs(ss)) return
        endif
        s(j+1)=s(j)
        h(j+1)=0.25*h(j)
11    continue
      pause 'too many steps in qromb2'
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE polint2(xa,ya,n,x,y,dy)
      INTEGER n,NMAX
      REAL dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=10)
      INTEGER i,m,ns
      REAL den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint2'
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE trapzd2(func,a,b,s,n)
      INTEGER n
      REAL a,b,s,func
      EXTERNAL func
      INTEGER it,j
      REAL del,sum,tnm,x
      if (n.eq.1) then
        s=0.5*(b-a)*(func(a)+func(b))
      else
        it=2**(n-2)
        tnm=it
        del=(b-a)/tnm
        x=a+0.5*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(x)
          x=x+del
11      continue
        s=0.5*(s+(b-a)*sum/tnm)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.


CCC QROMB3
      SUBROUTINE qromb3(func,z,a,b,ss)
      INTEGER JMAX,JMAXP,K,KM
      REAL a,b,func,ss,EPS,z
      EXTERNAL func
      PARAMETER (EPS=1.e-5, JMAX=100, JMAXP=JMAX+1, K=5, KM=K-1)
CU    USES polint3,trapzd3
      INTEGER j
      REAL dss,h(JMAXP),s(JMAXP)
      h(1)=1.
      do 11 j=1,JMAX
        call trapzd3(func,z,a,b,s(j),j)
        if (j.ge.K) then
          call polint3(h(j-KM),s(j-KM),K,0.,ss,dss)
          if (abs(dss).le.EPS*abs(ss)) return
        endif
        s(j+1)=s(j)
        h(j+1)=0.25*h(j)
11    continue
      pause 'too many steps in qromb3'
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE polint3(xa,ya,n,x,y,dy)
      INTEGER n,NMAX
      REAL dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=10)
      INTEGER i,m,ns
      REAL den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint3'
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE trapzd3(func,z,a,b,s,n)
      INTEGER n
      REAL a,b,s,func,z
      EXTERNAL func
      INTEGER it,j
      REAL del,sum,tnm,x
      if (n.eq.1) then
        s=0.5*(b-a)*(func(z,a)+func(z,b))
      else
        it=2**(n-2)
        tnm=it
        del=(b-a)/tnm
        x=a+0.5*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(z,x)
          x=x+del
11      continue
        s=0.5*(s+(b-a)*sum/tnm)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.




cccccc spline fitting ccccccccccccccccccccccccccccccccc
      SUBROUTINE splint(xa,ya,y2a,n,x,y)
      INTEGER n
      REAL x,y,xa(n),y2a(n),ya(n)
      INTEGER k,khi,klo
      REAL a,b,h
      klo=1
      khi=n
1     if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.0.) pause 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**
     *2)/6.
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE spline(x,y,n,yp1,ypn,y2)
      INTEGER n,NMAX
      REAL yp1,ypn,x(n),y(n),y2(n)
      PARAMETER (NMAX=500)
      INTEGER i,k
      REAL p,qn,sig,un,u(NMAX)
      if (yp1.gt..99e30) then
        y2(1)=0.
        u(1)=0.
      else
        y2(1)=-0.5
        u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
      endif
      do 11 i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2.
        y2(i)=(sig-1.)/p
        u(i)=(6.*((y(i+1)-y(i))/(x(i+
     *1)-x(i))-(y(i)-y(i-1))/(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*
     *u(i-1))/p
11    continue
      if (ypn.gt..99e30) then
        qn=0.
        un=0.
      else
        qn=0.5
        un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
      endif
      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
      do 12 k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
12    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.


ccc linear growth factor
      function gra(a,nstep,hrk,dplus)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      dimension dplus(0:nstep)
      x=a/hrk
      ix=int(x)
      dx=(x-ix)
      gra=dplus(ix)*(1.0-dx)+dplus(ix+1)*dx
      return
      end

      function omegade(a)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /cosmo/ om,ode,w0,wa
      omegade=(1.0-om)/
     $     (1.0-om+om*a**(3.0*(w0+wa))*exp(3.0*wa*(1.0-a)))
      return
      end

      function omegam(a)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /cosmo/ om,ode,w0,wa
      omegam=om/(1.0-om+om*a**(3.0*(w0+wa))*exp(3.0*wa*(1.0-a)))/a**3
      return
      end

      subroutine derivs(x,y,dy)
      implicit real (a-h,o-z) 
      implicit integer (i-n)
      common /cosmo/ om,ode,w0,wa

      parameter (n=2)
      real y(n),dy(n)
      
      a=x
      dy(1)=y(2)
      
      ww=w0+wa*(1.0-a)
      omede=omegade(a)

      dy(2)=-(3.5-1.5*ww*omede)*y(2)/a
     $     -1.5*(1.0-ww)*omede*y(1)/(a*a)
      
      return
      end
      
      SUBROUTINE rk4(y,dydx,n,x,h,yout,derivs)
      INTEGER n,NMAX
      REAL h,x,dydx(n),y(n),yout(n)
      EXTERNAL derivs
      PARAMETER (NMAX=50)
      INTEGER i
      REAL h6,hh,xh,dym(NMAX),dyt(NMAX),yt(NMAX)
      hh=h*0.5
      h6=h/6.
      xh=x+hh
      do 11 i=1,n
        yt(i)=y(i)+hh*dydx(i)
11    continue
      call derivs(xh,yt,dyt)
      do 12 i=1,n
        yt(i)=y(i)+hh*dyt(i)
12    continue
      call derivs(xh,yt,dym)
      do 13 i=1,n
        yt(i)=y(i)+h*dym(i)
        dym(i)=dyt(i)+dym(i)
13    continue
      call derivs(x+h,yt,dyt)
      do 14 i=1,n
        yout(i)=y(i)+h6*(dydx(i)+dyt(i)+2.*dym(i))
14    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
