ccc  nmhalo_m.f   Time-stamp: <2007-05-30 10:37:43 hamana>
ccc  need for a compile option that defines REAL declarations 
ccc  as DOUBLE PRECISION such like; "-real_size 64" (alpha), "-r8" (alpha)
ccc  VALID only for FLAT model
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /omegas/ omem,omev,omek
      common /matter_Pk/ gamfin,atps
      common /defs/ pi,tps,ch0,rn,onethr
      common /st/ p_st,a_st,st_norm

      external dldz

      include 'nmhalo_m.par'
      
      dimension dcountall(massmin:massmax)
      dimension countall(massmin:massmax)
      
      character*88 filename

ccc useful numbers
      pi=4.0*atan(1.0)
      arcmin2rad=pi/(180.0*60.0)
      domega_1sqdeg=tan(pi/180.0)**2
      tps=2.0*pi**2
      ch0=3000.0
      rn=8.0/ch0
      onethr=1.0/3.0
      rhocr=2.78e11 !h^2 M_sun/Mpc^3
      e2ten=2.30259 !ln(x)=ln(10)*log(x), ln(10)=e2ten
      zero=0.0

ccc flags
      igrfrag=-1

ccc mass function
      p_st=0.3  ! ST parameter 
      a_st=0.707  ! ST parameter 

ccc parameter input 
ccc cosmology
      read(*,*)hubp ! Hubble parameter
      read(*,*)omem ! Omega_matter
      read(*,*)omev ! Omega_lambda
      read(*,*)omebh2 ! Omega_b*hubp**2
      omeb=omebh2/hubp**2
      omek=omem+omev-1.0
      coefdnu=e2ten*delnu*0.75/pi*ch0**3*domega_1sqdeg
      r2mass=2.775e11*4.0*pi*omem/3.0
ccc Gamma factor
      gamfin=exp(omeb+sqrt(2.0*hubp)*omeb/omem)/
     $     (omem*hubp*ch0)

      read(*,*)sig8 ! sigma_8
ccc normalization
      call normPk(anrm,sig8)
      atps=anrm/tps
      
ccc zrange
      read(*,*)zmin,zmax
      asmin=1.0/(1.0+zmin)
      asmax=1.0/(1.0+zmax)
      as=1.0/(1.0+zmax)

      delas=(asmin-asmax)/inta
            
ccc output file name
      read(*,'(a88)')filename

ccc pre-compute ST mass function
      call int_st(st_norm)

ccc pre-compute sigma-R relation at z=0
      call int_sigmar

ccc Comoving angular diameter distances to source !Valid only flat model
      call qromb(dldz,as,1.0,ss)
      ds=ss

clear array
      countall=0.0

C===== below thie line quantities depend on the lens redshift =====
ccc al(zl)->chi
      do 31 iz=1,inta ! loop for lens redshift
         al=asmin-iz*delas
         call qromb(dldz,al,1.0,ss)
         dl=ss
         dchida=dldz(al)
         fchi=delas*dchida*dl**2

ccc growth rate at zl
         g=gr(al,igrfrag)
         ga2=(g*al)**2

ccc Virial overdensity delta_vir at zl
         call deltas(al,deltac,deltavir)
         deltac2=deltac**2
         deltavir3=deltavir**onethr

C===== below this line quantities depends also on the halo mass =====
ccc clear array
         dcountall=0.0
         do 30 inu=numin,numax  ! loop for nu
cccccc for nu=nu(inu))
            anu=10.0**(inu*delnu) ! nu
            sigma2_nu=deltac2/anu ! sigma^2
            rnu=sigma2r(sigma2_nu,ga2) ! R
            dn=st_norm*fnu_nu(anu)
ccc Virial radius and r_lin(M)
            rlin=rnu
            rvir=rlin/deltavir3
            flnnu=coefdnu*dn/rlin**3
ccc virial mass
            hmass=r2mass*rnu**3
            imass=nint(log10(hmass)/delmass)
            if (imass.ge.massmin.and.imass.le.massmax)
     $           dcountall(imass)=dcountall(imass)+flnnu*0.5
            
cccccc for nu=(nu(inu-1)+nu(inu))/2
            anu=10.0**((inu-0.5)*delnu) ! nu 
            sigma2_nu=deltac2/anu ! sigma^2
            rnu=sigma2r(sigma2_nu,ga2) ! R
            dn=st_norm*fnu_nu(anu)
ccc Virial radius and r_lin(M)
            rlin=rnu
            rvir=rlin/deltavir3
            flnnu=coefdnu*dn/rlin**3
ccc virial mass
            hmass=r2mass*rnu**3
            imass=nint(log10(hmass)/delmass)
            if (imass.ge.massmin.and.imass.le.massmax)
     $           dcountall(imass)=dcountall(imass)+flnnu*0.5
30      continue
        do im=massmin,massmax
           dcountall(im)=dcountall(im)*fchi
           countall(im)=countall(im)+dcountall(im)
        enddo
 31   continue

      totcount=0.0
      do im=massmin,massmax
         countall(im)=countall(im)
      enddo

      open(10,file=filename,STATUS= 'UNKNOWN')
      tot2=0.0
      do im=massmax,massmin,-1
         x=10.0**(im*delmass)
         dndmall=countall(im)/delmass
         tot2=tot2+countall(im)
         write(10,100)x,dndmall,tot2
      enddo
 100  format(3(1pe13.5))
      write(10,101)'#########################################'
      write(10,101)'# col-1: M[Msolar/h]                     '
      write(10,101)'# col-2: dNhalo/dlogM[/sq degree]        '
      write(10,101)'# col-3: Nhalo(>M)   [/sq degree]        '
      write(10,101)'### cosmology ###########################'
      write(10,102)'# Hubble param=',hubp
      write(10,102)'# Omega_M     =',omem
      write(10,102)'# Omega_lambda=',omev
      write(10,102)'# Omega_b     =',omeb
      write(10,102)'# sigma_8     =',sig8
      write(10,103)'# CDM TF = BBKS+S95'
      close(10)
 101  format(a41)
 102  format(a15,1pe12.5)
 103  format(a19)
      end

ccc Sheth & Tormen mass function ! NOT normalized
      function fnu_nu(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /st/ p,a,st_norm
      y=a*x
      fnu_nu=(1.0+1.0/y**p)*sqrt(y)*exp(-0.5*y)
      return
      end
ccc normalization of Sheth & Tormen mass function    
      subroutine int_st(st_norm)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      external fnu_nu_log
      amin=-80.0
      amax=80.0
      call qromb(fnu_nu_log,amin,amax,ss)
      st_norm=1.0/ss
      return
      end
      function fnu_nu_log(z)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /st/ p,a,st_norm
      x=exp(z)
      y=a*x
      fnu_nu_log=(1.0+y**(-p))*sqrt(y)*exp(-0.5*y)
      return
      end

ccc delta_c and delta_vir 
ccc VALID only FLAT model
      subroutine deltas(a,deltac,deltavir)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /omegas/ omem,omev,omek
      common /defs/ pi,tps,ch0,rn,onethr
      x=a*(1.0/omem-1.0)**(1.0/3.0)
      deltac=3.0*(12.0*pi)**(2.0/3.0)/20.0*
     $     (1.0-0.00123*log10(1.0+x**3))
      deltavir=18.0*pi**2*(1.0+0.4093*x**2.71572)
      return
      end


      subroutine search_rast(rast,ga2,deltac2)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigma_r_relation/ sigmar0,r0,drdsig1,drdsig2
      include 'nmhalo_m.par'
      dimension sigmar0(irall)
      dimension r0(irall)
      sig0=log(deltac2/ga2)
      call hunt(sigmar0,irall,sig0,jlo)
      d=(r0(jlo+1)-r0(jlo))/(sigmar0(jlo+1)-sigmar0(jlo))
      r1=d*(sig0-sigmar0(jlo))+r0(jlo)
      rast=exp(r1)
      return
      end
ccc sigma_R - R relation
      subroutine int_sigmar
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigma_r_relation/ sigmar0,r0,drdsig1,drdsig2
      include 'nmhalo_m.par'
      dimension sigmar0(irall)
      dimension r0(irall)
      do 10 i=1,irall
         ii=irmax-i+1
         x=10.0**(delr*ii)
         r0(i)=log(x)
         sigmar0(i)=log(sigma_r(x)) ! Notice sigma_r(x)=sigma_R^2
 10   continue
      drdsig1=(r0(2)-r0(1))/(sigmar0(2)-sigmar0(1))
      drdsig2=(r0(irall)-r0(irall-1))/
     $     (sigmar0(irall)-sigmar0(irall-1))
      return
      end
ccc
      function sigma2r(sig,ga2)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigma_r_relation/ sigmar0,r0,drdsig1,drdsig2
      include 'nmhalo_m.par'
      dimension sigmar0(irall)
      dimension r0(irall)
      sig0=log(sig/ga2)
      if (sig0.le.sigmar0(1)) then
         y=r0(1)+drdsig1*(sig0-sigmar0(1))
      elseif (sig0.ge.sigmar0(irall)) then
         y=r0(irall)+drdsig2*(sig0-sigmar0(irall))
      else
         call hunt(sigmar0,irall,sig0,jlo)
         d=(r0(jlo+1)-r0(jlo))/(sigmar0(jlo+1)-sigmar0(jlo))
         y=d*(sig0-sigmar0(jlo))+r0(jlo)
      endif
      sigma2r=exp(y)
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccc
      function sigma_r(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /defs/ pi,tps,ch0,rn,onethr
      common /sigmar/rsmooth
      external dsigma_r
      wmin=-30.0
      wmax=40.0
      rsmooth=x/ch0
      call qromb(dsigma_r,wmin,wmax,ss)
      sigma_r=ss
      return
      end   
ccccccccccccccccccccccccccccccccccccccccccccc
      function dsigma_r(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /sigmar/rsmooth
      w=exp(x)
      rk=rsmooth*w
      dsigma_r=delta_lin0(w)*filtTH(rk)**2
      return
      end 
ccccccccccccccccccccccccccccccccccccccccccccc
      function delta_lin0(w)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /matter_Pk/ gfin,atps
      q=w*gfin
      delta_lin0=atps*trnf2(q)*w**4
      return
      end 

cccccccccc normalization of power spectrum 
      subroutine normPk(a_norm,sig8)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      external delta
      common /defs/ pi,tps,ch0,rn,onethr
      wmin=-30.0
      wmax=40.0
      call qromb(delta,wmin,wmax,seki)
      y=seki/tps
      a_norm=sig8*sig8/y
      return
      end
ccccccccc
      function delta(x)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /defs/ pi,tps,ch0,rn,onethr
      common /matter_Pk/ gfin,atps
      w=exp(x)
      q=w*gfin
      r=w*rn
      filt=filtTH(r)
      tranf=trnf2(q)
      delta=w**4*filt*filt*tranf
      return
      end
ccccccccc
      function filtTH(r)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      filtTH=3.0*(sin(r)-r*cos(r))/r**3
      return
      end
ccccccccc 
      function trnf2(q)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /matter_Pk/ gamfin,atps
      qq=q*q
      trnf2=0.182628*log(1.0+2.34*q)**2/qq
     $     /sqrt(1.0+3.89*q+259.21*qq
     $     +162.77*qq*q+2027.17*qq*qq)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      function gr(a,igrfrag)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /omegas/ omem,omev,omek
      save grnorm
      if (igrfrag.eq.-1) then
         pre=1.0
         et=1.0/e(pre)
         ot=omem*et
         vt=omev*et
         grnorm=0.4*(ot**(0.571428571)-vt+
     $        (1.0+0.5*ot)*(1.0+vt*0.014285714))/ot
         igrfrag=1
      endif
      et=1.0/e(a)
      ot=omem*a*et
      vt=omev*et*a**4
      graw=2.5*ot/(ot**(0.571428571)-vt+
     $     (1.0+0.5*ot)*(1.0+vt*0.014285714))
      gr=graw*grnorm
      return
      end
ccc      
      function e(a)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /omegas/ omem,omev,omek
      a2=a*a
      e=a*omem-a2*omek+a2*a2*omev
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
ccc  package of solving the integral equation of 
ccc  affine parameter - redshit (scale factor) relation
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function dldz(a)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      common /omegas/ om,ov,ok
      a2=a*a
      dldz=1.0/sqrt(a*om-a2*ok+a2*a2*ov)      
      return
      end
cc

      SUBROUTINE qromb(func,a,b,ss)
      INTEGER JMAX,JMAXP,K,KM
      REAL a,b,func,ss,EPS
      EXTERNAL func
      PARAMETER (EPS=1.e-6, JMAX=40, JMAXP=JMAX+1, K=10, KM=K-1)
CU    USES polint,trapzd
      INTEGER j
      REAL dss,h(JMAXP),s(JMAXP)
      h(1)=1.
      do 11 j=1,JMAX
        call trapzd(func,a,b,s(j),j)
        if (j.ge.K) then
          call polint(h(j-KM),s(j-KM),K,0.,ss,dss)
          if (abs(dss).le.EPS*abs(ss)) return
        endif
        s(j+1)=s(j)
        h(j+1)=0.25*h(j)
11    continue
      pause 'too many steps in qromb'
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE polint(xa,ya,n,x,y,dy)
      INTEGER n,NMAX
      REAL dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=20)
      INTEGER i,m,ns
      REAL den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint'
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE trapzd(func,a,b,s,n)
      INTEGER n
      REAL a,b,s,func
      EXTERNAL func
      INTEGER it,j
      REAL del,sum,tnm,x
      if (n.eq.1) then
        s=0.5*(b-a)*(func(a)+func(b))
      else
        it=2**(n-2)
        tnm=it
        del=(b-a)/tnm
        x=a+0.5*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(x)
          x=x+del
11      continue
        s=0.5*(s+(b-a)*sum/tnm)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.

      SUBROUTINE hunt(xx,n,x,jlo)
      INTEGER jlo,n
      REAL x,xx(n)
      INTEGER inc,jhi,jm
      LOGICAL ascnd
      ascnd=xx(n).gt.xx(1)
      if(jlo.le.0.or.jlo.gt.n)then
        jlo=0
        jhi=n+1
        goto 3
      endif
      inc=1
      if(x.ge.xx(jlo).eqv.ascnd)then
1       jhi=jlo+inc
        if(jhi.gt.n)then
          jhi=n+1
        else if(x.ge.xx(jhi).eqv.ascnd)then
          jlo=jhi
          inc=inc+inc
          goto 1
        endif
      else
        jhi=jlo
2       jlo=jhi-inc
        if(jlo.lt.1)then
          jlo=0
        else if(x.lt.xx(jlo).eqv.ascnd)then
          jhi=jlo
          inc=inc+inc
          goto 2
        endif
      endif
3     if(jhi-jlo.eq.1)return
      jm=(jhi+jlo)/2
      if(x.gt.xx(jm).eqv.ascnd)then
        jlo=jm
      else
        jhi=jm
      endif
      goto 3
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.


      SUBROUTINE qromb2(func,a,b,ss)
      INTEGER JMAX,JMAXP,K,KM
      REAL a,b,func,ss,EPS
      EXTERNAL func
      PARAMETER (EPS=1.e-6, JMAX=40, JMAXP=JMAX+1, K=10, KM=K-1)
CU    USES polint2,trapzd2
      INTEGER j
      REAL dss,h(JMAXP),s(JMAXP)
      h(1)=1.
      do 11 j=1,JMAX
        call trapzd2(func,a,b,s(j),j)
        if (j.ge.K) then
          call polint2(h(j-KM),s(j-KM),K,0.,ss,dss)
          if (abs(dss).le.EPS*abs(ss)) return
        endif
        s(j+1)=s(j)
        h(j+1)=0.25*h(j)
11    continue
      pause 'too many steps in qromb'
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE polint2(xa,ya,n,x,y,dy)
      INTEGER n,NMAX
      REAL dy,x,y,xa(n),ya(n)
      PARAMETER (NMAX=20)
      INTEGER i,m,ns
      REAL den,dif,dift,ho,hp,w,c(NMAX),d(NMAX)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause 'failure in polint'
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.
      SUBROUTINE trapzd2(func,a,b,s,n)
      INTEGER n
      REAL a,b,s,func
      EXTERNAL func
      INTEGER it,j
      REAL del,sum,tnm,x
      if (n.eq.1) then
        s=0.5*(b-a)*(func(a)+func(b))
      else
        it=2**(n-2)
        tnm=it
        del=(b-a)/tnm
        x=a+0.5*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(x)
          x=x+del
11      continue
        s=0.5*(s+(b-a)*sum/tnm)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 41m.

ccc spline fitting package
      SUBROUTINE splint(xa,ya,y2a,imin,imax,x,y)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      dimension xa(imin:imax)
      dimension y2a(imin:imax)
      dimension ya(imin:imax)
      klo=imin
      khi=imax
      zero=0.0
 1    if (khi-klo.gt.1) then
         k=(khi+klo)/2
         if(xa(k).gt.x)then
            khi=k
         else
            klo=k
         endif
         goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.zero) pause 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+
     $     (b**3-b)*y2a(khi))*(h**2)/6.0
      return
      END
c
      SUBROUTINE spline(x,y,imin,imax,yp1,ypn,y2)
      implicit real (a-h,o-z)
      implicit integer (i-n)
      dimension x(imin:imax)
      dimension y(imin:imax)
      dimension y2(imin:imax)
      PARAMETER (iNMAX=5000)
      dimension u(-iNMAX:iNMAX)
      if (yp1.gt.0.99e30) then
        y2(imin)=0.0
        u(imin)=0.0
      else
         y2(imin)=-0.5
         u(imin)=(3.0/(x(imin+1)-x(imin)))*((y(imin+1)
     $        -y(imin))/(x(imin+1)-x(imin))-yp1)
      endif
      do 11 i=imin+1,imax-1
         sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
         p=sig*y2(i-1)+2.0
         y2(i)=(sig-1.)/p
         u(i)=(6.0*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1))/
     $        (x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
11    continue
      if (ypn.gt.0.99e30) then
         qn=0.0
         un=0.0
      else
         qn=0.5
         un=(3.0/(x(imax)-x(imax-1)))*(ypn-(y(imax)-y(imax-1))/
     $        (x(imax)-x(imax-1)))
      endif
      y2(imax)=(un-qn*u(imax-1))/(qn*y2(imax-1)+1.0)
      do 12 k=imax-1,imin,-1
         y2(k)=y2(k)*y2(k+1)+u(k)
12    continue
      return
      END
